"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const redux_actions_1 = require("redux-actions");
const AsyncActionControl_1 = require("./AsyncActionControl");
const utils_1 = require("./utils");
const START = 'START';
const SUCCESS = 'SUCCESS';
const FAILURE = 'FAILURE';
const CANCEL = 'CANCEL';
const STATUS_LIST = [START, SUCCESS, FAILURE, CANCEL];
function createAsyncAction(actionName, prefix) {
    const asyncActionsMapper = {};
    const asyncLabelsMapper = {};
    STATUS_LIST.forEach((status) => {
        const fetchActionName = `${actionName}_${status}`;
        asyncLabelsMapper[status] = {
            label: utils_1.camelCase(fetchActionName),
        };
        asyncActionsMapper[fetchActionName] = [
            (payload) => payload,
            (payload, meta) => meta,
        ];
    });
    const { [asyncLabelsMapper[START].label]: start, [asyncLabelsMapper[SUCCESS].label]: success, [asyncLabelsMapper[FAILURE].label]: failure, [asyncLabelsMapper[CANCEL].label]: cancel, } = redux_actions_1.createActions(asyncActionsMapper, { prefix });
    return new AsyncActionControl_1.default(actionName, {
        start,
        success,
        failure,
        cancel,
    });
}
exports.default = createAsyncAction;
